HDU-1498-50years,50colors(最大匹配, 枚举)

HDU-1498-50years,50colors(最大匹配, 枚举)

链接:https://vjudge.net/problem/HDU-1498#author=634579757

题意:

撞气球游戏,一个n*n的矩阵中,有不同颜色的气球,气球的颜色最多50种(从1到50)。 
游戏开始前,先选择一种颜色。游戏开始后,每次选择一行或者一列包含该种颜色的气球进行撞击。如果选择行,那么这一行的气球都会炸裂。如果选择列,这一列的气球都炸裂。 
请你求出,有多少种颜色的气球,无论怎么玩,都不能在K次之内,把所有同色的气球都撞裂。

思路:

二分图匹配, 用set记录所有存在的颜色,然后根据x,y求最大匹配,条件是Map[i][j] == color。

最大匹配大于k即可。

代码:

#include <iostream>
#include <memory.h>
#include <string>
#include <istream>
#include <sstream>
#include <vector>
#include <stack>
#include <algorithm>
#include <map>
#include <queue>
#include <math.h>
#include <cstdio>
#include <set>
#include <iterator>
#include <cstring>
using namespace std;

typedef long long LL;
const int MAXN = 2000+10;
vector<int> G[MAXN];
int Map[200][200];
int Link[MAXN], Vis[MAXN];
int n, m, k;
int mid;

void Init()
{
    for (int i = 1;i <= n;i++)
        G[i].clear();
}

bool Dfs(int x)
{
    for (int i = 1;i <= n;i++)
    {
        if (Map[x][i] == mid && Vis[i] == 0)
        {
            Vis[i] = 1;
            if (Link[i] == -1 || Dfs(Link[i]))
            {
                Link[i] = x;
                return true;
            }
        }
    }
    return false;
}

int Solve()
{
    memset(Link, -1, sizeof(Link));
    int cnt = 0;
    for (int i = 1;i <= n;i++)
    {
        memset(Vis, 0, sizeof(Vis));
        if (Dfs(i))
            cnt++;
    }
    return cnt;
}

int main()
{
    while (~scanf("%d%d", &n, &m) && n)
    {
        set<int> node;
        memset(Map, 0, sizeof(Map));
        for (int i = 1;i <= n;i++)
        {
            for (int j = 1;j <= n;j++)
            {
                cin >> Map[i][j];
                node.insert(Map[i][j]);
            }
        }
        vector<int> Out;
        for (set<int>::iterator it = node.begin();it != node.end();it++)
        {
            mid = *it;
            int tmp = Solve();
            if (tmp > m)
                Out.push_back(mid);
        }
        if (!Out.size())
            cout << -1 << endl;
        else
        {
            cout << Out[0];
            for (int i = 1;i < Out.size();i++)
                cout << ' ' << Out[i];
            cout << endl;
        }
    }

    return 0;
}

  

转载于:https://www.cnblogs.com/YDDDD/p/10870344.html

版权声明:本文内容由互联网用户自发贡献,该文观点仅代表作者本人。本站仅提供信息存储空间服务,不拥有所有权,不承担相关法律责任。如发现本站有涉嫌侵权/违法违规的内容, 请发送邮件至 举报,一经查实,本站将立刻删除。

发布者:全栈程序员-站长,转载请注明出处:https://javaforall.net/100920.html原文链接:https://javaforall.net

赞 (0)
全栈程序员-站长的头像全栈程序员-站长


相关推荐

  • B站视频资料汇总

    B站视频资料汇总前言B站个人空间:大大鹏I6将B站一些学习视频的课件,源码等资料的地址汇总在这篇博客,方便学习地址汇总北京理工大学嵩天教授的Python语言程序设计课程视频地址资料地址…

    2022年5月16日
  • mysql中分组排序_oracle先分组后排序

    mysql中分组排序_oracle先分组后排序文章目录MySQL窗口函数(分组内排序、筛选)简介与GROUPBY区别窗口函数语法`partition_clause`句法`order_by_clause`句法`frame_clause`句法MySQL窗口函数列表聚合函数+over()排序函数+over()ntile()函数+over()first_value()函数+over()lag()函数+over()last_value()函数+over()lead()函数+over()nth_value()函数+over(

    2022年9月27日
  • 二阶带通滤波器电路设计

    二阶带通滤波器电路设计一、实验目的掌握有源滤波器电路设计基本方法。掌握电路仿真软件的基本使用方法。二、实验内容及结果实验内容参考查表法或辅助软件法,利用集成运放设计二阶音频滤波器,实现音频信号的消噪。假设输入信号幅度在0.1Vpp以内,要求通带增益为0dB,3dB截止频率分别为20Hz~20kHz,通道增益要求平坦,电路负载为1kΩ。根据上述要求设计出该电路,并对该电路的幅频特性进行仿真。实验具体要求如下:(1)设计电路,说明设计原理,电阻、电容选择为系列值,要求截至频率误差在10%以内。(2)确定电路中

    2022年5月2日
  • IDEA下maven分模块开发,web块不能创建serlvet的问题的解决方案

    IDEA下maven分模块开发,web块不能创建serlvet的问题的解决方案

    2021年8月23日
  • JAVA常用框架及漏洞[通俗易懂]

    JAVA常用框架及漏洞[通俗易懂]三大语言常用框架及漏洞Java框架1.MyBatis是支持定制化SQL、存储过程以及高级映射的优秀的持久层框架,其主要就完成2件事情:封装JDBC操作 利用反射打通Java类与SQL语句之间的相互转换MyBatis的主要设计目的就是让我们对执行SQL语句时对输入输出的数据管理更加方便,所以方便地写出SQL和方便地获取SQL的执行结果才是MyBatis的核心竞争力。…

    2022年7月7日
  • SpringBoot——整合Shiro完成登录检验

    SpringBoot——整合Shiro完成登录检验SpringBoot——整合Shiro完成登录检验

    2022年4月23日

发表回复

您的邮箱地址不会被公开。 必填项已用 * 标注

关注全栈程序员社区公众号